package Aggregation;

import PrologDB.Tuple;

/** 
 * this aggregation function returns the designated column value
 * of the first tuple of a table.  The table itself is assumed
 * to be the result of a group by, where all tuples have the same
 * designated column value
 */
public class GroupValue extends Reducer {
    String Agg;
    String columnName;
    
    public GroupValue(String outFieldName, String inFieldName) {
        super(outFieldName);
        this.columnName = inFieldName;
        reset();
    }

    public void add(Tuple t) {
        if (Agg==null)
            Agg = t.get(columnName);
    }

    public String[] getAccumulated() {
        String[] result = new String[1];
        result[0] = Agg;
        return result;
    }

    @Override
    public void reset() {
        Agg = null;
    }
}
