package Aggregation;

import PrologDB.Tuple;

/**
 * use for integer aggregations
 */
public class IntSum extends Reducer {
    int agg;
    String inputFieldName;

    /**
     *
     * @param outFieldName - column descriptor of aggregate output column 
     * (use "n" or "'n'" for name n and indicate if values are quoted
     * @param inFieldName -- name of inter-valued column to be summed
     */
    public IntSum(String outFieldName, String inFieldName) {
        super(outFieldName);
        reset();
        this.inputFieldName = inFieldName;
    }

    @Override
    public void add(Tuple t) {
        agg = t.getInt(inputFieldName)+agg;
    }

    public String[] getAccumulated() {
        String[] result = new String[1];
        result[0] = agg + "";
        return result;
    }

    @Override
    public void reset() {
        agg = 0;
    }
}
