
package Aggregation;

import PrologDB.Column;
import PrologDB.Tuple;


public abstract class Reducer {
    protected Column[] accCols;
    protected String[] justColNames;
    
    public Reducer(String fieldName) {
        accCols = new Column[1];
        accCols[0] = new Column(fieldName);
        setJustFieldNames();
        if (accCols.length != justColNames.length) 
            throw MDLUtilities.Error.toss(MDLUtilities.Error.columnValuesBad,accCols.length,justColNames.length);
    }
    
    public Reducer(String... fieldNames) {
        this.accCols = Column.New(fieldNames);
        setJustFieldNames();
    }
    
    private void setJustFieldNames() {
        justColNames = new String[accCols.length];
        for (int i=0; i<accCols.length; i++) {
            justColNames[i] = accCols[i].getName();
        }
    }
    
    public abstract void add(Tuple t);

    public abstract String[] getAccumulated();
    
    public abstract void reset();
    
    public Column[] getColumns() {
        return accCols;
    }
    
    public String[] getColumnNames() {
        return justColNames;
    }
}
