package Boot.MDELite;

public class catalina extends Common {

    public static void main(String... args) {
        main(catalina.class, args, current, domains.values(),
             paths.values(),arrows.values());
    }

    static enum domains implements IEnum {
        state(".state.violet"),
        fsm(".fsm.pl"),
        meta(".meta.pl"),
        java(".java"),
        ;

        public String data; // file type ending

        private domains(String end) {
            this.data = end;
        }

        @Override
        public String getEnd() {
            return data;
        }

        public static domains[] list(domains... args) {
            return args;
        }
    };

    static enum arrows implements PEnum {
        fsmConform( new Triple(
          a -> Boot.MDELite.CategoryConform.main(a),
          domains.list(domains.fsm),
          new domains[0])),
        metaConform( new Triple(
          a -> Boot.MDELite.MetaConform.main(a),
          domains.list(domains.meta),
          new domains[0])),
        parse( new Triple(
          a -> Violett.StateParser.main(a),
          domains.list(domains.state),
          domains.list(domains.fsm))),
        m2m( new Triple(
          a -> Boot.MDELite.fsm2meta.main(a),
          domains.list(domains.fsm),
          domains.list(domains.meta))),
        m2t( new Triple(
          a -> Boot.MDELite.meta2java.main(a),
          domains.list(domains.meta),
          domains.list(domains.java))),
        ;

        private final Triple data;

        private arrows(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }

    static enum paths implements PEnum {
        all( new Triple(
          a -> catalina.all(a),
          domains.list(domains.state),
          domains.list(domains.java))),
        validateViolet( new Triple(
          a -> catalina.validateViolet(a),
          domains.list(domains.state),
          new domains[0])),
        validateMeta( new Triple(
          a -> catalina.validateMeta(a),
          domains.list(domains.state),
          domains.list(domains.meta))),
        quick( new Triple(
          a -> catalina.quick(a),
          domains.list(domains.meta),
          domains.list(domains.java))),
        ;

        private final Triple data;

        private paths(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }

    public static void all(String[] args) {
        enoughCommandLineArguments(paths.all, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        invoke(arrows.m2m, current);
        invoke(arrows.metaConform, current);
        invoke(arrows.m2t, current);
        completed(paths.all);
    }

    public static void validateViolet(String[] args) {
        enoughCommandLineArguments(paths.validateViolet, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        completed(paths.validateViolet);
    }

    public static void validateMeta(String[] args) {
        enoughCommandLineArguments(paths.validateMeta, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        invoke(arrows.m2m, current);
        invoke(arrows.metaConform, current);
        completed(paths.validateMeta);
    }

    public static void quick(String[] args) {
        enoughCommandLineArguments(paths.quick, args);

        invoke(arrows.m2t, current);
        completed(paths.quick);
    }
}

