package MDL;

import MDLUtilities.Marquee1In_0Out;
import PrologDB.DB;
import PrologDB.ErrorReport;

/**
 * MDL program that reads a database file and reports errors (other than
 * constraint violations) and prettyprints
 */
public class PrettyPrintDB {

    /**
     * reads database X.S.pl and reports errors, if any;  Schema 
     * constraints not applied/evaluated.
     * @param args -- X.S.pl
     */
    public static void main(String... args) {
        // Step 1: standard marquee processing
        Marquee1In_0Out mark = new Marquee1In_0Out(PrettyPrintDB.class, ".pl", args);
        String inputFileName = mark.getInputFileName();

        // Step 2: do the work
        DB db = DB.read(inputFileName);
        db.prettyPrint();
        ErrorReport er = new ErrorReport();
        db.StandardConform(er,true);
    }
}
