package MDL;

import PrologDB.Table;

/**
 * MDL program that reads a database file and reports errors (other than
 * constraint violations) and prettyprints
 */
public class PrettyPrintTable {

    /**
     * reads table X.S.pl or X.S.csv and reports errors, if any;  Schema 
     * constraints not applied/evaluated.
     * @param args -- X.S.pl
     */
    public static void main(String... args) {
        // Step 1: standard marquee processing
        if (!(args.length==1 && args[0].endsWith(".cvs")) && args[0].endsWith(".pl")) {
            System.out.format("Usage: %s <tableName>\n");
            System.out.format("       <tableName> or <tableName>.pl or <tableName>.csv\n");
            return;
        }
        String inputFileName = args[0];

        // Step 2: do the work
        Table db = Table.read(inputFileName);
        db.prettyPrint();
    }
}
