package MDL;

import MDLUtilities.Marquee2In_0Out;
import PrologDB.DB;
import PrologDB.DBSchema;
import PrologDB.Schema;

/**
 * MDL program that reads a database file and a dbase schema,
 * verifies the the database schema is a superset of db schema,
 * and projects out the new database
 */
public class ProjectDBbySubSchema {

    /**
     * input db.schema1.pl schema2.schema.pl 
     * if schema2 is a subschema of schema1, project db to the contents
     * of schema2.
     * @param args (see above)
     */
    public static void main(String... args) {
        // Step 1: standard marquee processing
        Marquee2In_0Out mark = new Marquee2In_0Out(ProjectDBbySubSchema.class, ".pl", ".schema.pl", args);
        String inDBName = mark.getInputFileName();
        String smallerSchema = mark.getInputFileName1();
        String[] parsed = MDLUtilities.Utils.parseFileName(smallerSchema);
        String subSchemaName = parsed[2];
        parsed = MDLUtilities.Utils.parseFileName(inDBName);
        String AppName = parsed[2];
        
        // Step 2: open the files for precondition checks
        DB db = DB.read(inDBName);
        Schema dbs = db.getSchema();
        DBSchema ndbs = DBSchema.read(smallerSchema);
        ndbs.isSubSchemaOf(ndbs);
        
        // Step 3: do the work
        DB smallerDB = db.project(ndbs);
        String outputFileName = AppName + "." + subSchemaName +".pl";
        smallerDB.print(outputFileName);
    }
}
