package MDL;

import PrologDB.DBSchema;
import PrologDB.OOSchema;

/**
 * reads a schema or ooschema and reports errors
 */
public class ReadSchema {

    /**
     * standard marquee for an MDL program
     */
    static void marquee(String msg, String type) {
        String className = ReadSchema.class.getName();
        System.out.format("\nUsage: %s <X>.%s.pl\n", className, type);
        System.out.format("       reads %s X and reports errors\n", type);
        if (msg != null) {
            System.out.format("       %s\n", msg);
        }
        System.exit(0);
    }

    /* reads database -- outputs errors */
    /**
     * reads schema from any ooschema or schema file and throws Error if errors
     * are found.
     *
     * @param args -- X.S.pl, where S = ooschema or schema
     */
    public static void main(String... args) {
        if (args.length == 0) {
            marquee(null, "ooschema or schema");
        }
        if (args.length != 1 || !args[0].endsWith(".pl")) {
            marquee(args[0] + " submitted as input", "ooschema or schema");
        }
        if (args[0].endsWith("ooschema.pl")) {
            OOSchema.read(args[0]);
        } else if (args[0].endsWith("schema.pl")) {
            DBSchema.read(args[0]);
        } else {
            marquee(args[0] + " submitted as input", "ooschema.pl or schema.pl");
        }
    }
}
