package MDLUtilities;

/** general Marquee 1 argument programs */
public class Marquee2In_0Out extends MarqueeCommon {

    /** general Marquee for all 2 input programs 
     * standard usage:
        Marquee2In_0Out mark = new Marquee2In_0Out(THIS.class, ".a.b", ".c.d", args);
        String inputFileName = mark.getInputFileName();
        String inputFileName1 = mark.getInputFileName1();
        String AppName = mark.getAppName();
     * @param cls -- class object of the Conformance Program
     * @param pattern1 -- file pattern (".meta.pl") to match/process
     * @param pattern2 -- file pattern (".meta.pl") to match/process
     * @param args -- from main(args)
     */
    public Marquee2In_0Out(Class cls, String pattern1, String pattern2, String args[]) {
        this.cls = cls;
        this.inputPattern1 = pattern1;
        this.inputPattern2 = pattern2;
        this.args = args;
        insist(2);
    }
    
    /** to pacify whiney compiler */
    private Marquee2In_0Out() {}
   

    /**
     * display generic marquee for Conformance files
     * @param msg -- specialized error message to print, otherwise ""
     */
    public void displayMarquee(String msg) {
        System.out.format("\nUsage: %s arg1%s arg2%s\n", cls.getName(), inputPattern1, inputPattern2);
        if(msg!=null) {
            System.out.format("\n       %s\n", msg);
        }
        System.exit(0);
    }

    /**
     * @return  name of the input file that is to be validated
     */
    @Override
    public String getInputFileName() {
        if (!args[0].contains(".")) //NEW
            return args[0]+inputPattern1;
        if (!args[0].endsWith(inputPattern1)) {
            displayMarquee(args[0] + " submitted as input");
        }
        return args[0];
    }
    
    /**
     * @return  name of 2nd input file 
     */
    public String getInputFileName1() {
        if (!args[1].contains(".")) //NEW
            return args[1]+inputPattern2;
        if (!args[1].endsWith(inputPattern2)) {
            displayMarquee(args[1] + " submitted as input");
        }
        return args[1];
    }

}
