package Parsing.DBPrimitives.FixedStrTokens;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * a Comma is a "," token
 */
public class Comma extends FixedStringToken {

    public static final String tok = ",";

    /**
     * Standard constructor
     */
    public Comma() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line t parse
     */
    public Comma(LineToParse l) {
        super(l, false);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public String getEmsg() {
        return "comma";
    }

    @Override
    public Comma klone(LineToParse l) {
        return new Comma(l);
    }
}
