package Parsing.DBPrimitives.FixedStrTokens;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * left bracket '[' token
 */
public class LeftBracket extends FixedStringToken {

    public static final String tok = "[";

    /**
     * Standard constructor
     */
    public LeftBracket() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public LeftBracket(LineToParse l) {
        super(l, false);
    }

    @Override
    public LeftBracket klone(LineToParse l) {
        return new LeftBracket(l);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
