package Parsing.DBPrimitives.Lists;

import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.NonEmptyList;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/** a NameList is Name(,Name)* */
public class NameList extends NonEmptyList { // comma separated names
    
    /** Standard constructor */
    public NameList() {
        super(new Name(), new Comma(),true);
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public NameList(LineToParse l) {
        super( new Name(), new Comma(), l, true);
    }

    @Override
    public NameList klone(LineToParse l) {
        return new NameList(l);
    }
}
