package Parsing.DBPrimitives.Patterns;

import Parsing.DBPrimitives.Lists.NameList;
import Parsing.DBPrimitives.FixedStrTokens.SubTaBle;
import Parsing.DBPrimitives.FixedStrTokens.RightParen;
import Parsing.DBPrimitives.FixedStrTokens.RightBracket;
import Parsing.DBPrimitives.FixedStrTokens.LeftParen;
import Parsing.DBPrimitives.FixedStrTokens.LeftBracket;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/** subtable statement: subtable(name,[ name1,name2... ]). */
public class SubTableStmt extends Pattern {

    /** Standard constructor */
    public SubTableStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public SubTableStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new SubTaBle(), new LeftParen(), new Name(), new Comma(), 
             new LeftBracket(), new NameList(), new RightBracket(), 
             new RightParen(), new Dot(), new End()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public SubTableStmt klone(LineToParse l) {
        return new SubTableStmt(l);
    }
}
