package Parsing.DBPrimitives.Patterns;

import Parsing.DBPrimitives.FixedStrTokens.RightParen;
import Parsing.DBPrimitives.FixedStrTokens.LeftParen;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.DBPrimitives.Lists.TupleValues;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/** tuple statement : name( TupleValues ). */
public class TupleStmt extends Pattern {

    /** Standard constructor */
    public TupleStmt() {
        super();
    }
    
    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public TupleStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Name(), new LeftParen(), new TupleValues(), 
             new RightParen(), new Dot(), new End() };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public TupleStmt klone(LineToParse l) {
        return new TupleStmt(l);
    }
}
