
package Parsing.DBPrimitives.Patterns;

// extended column declaration

import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.GeneralPrimitives.PrimTokens.QuotedString;
import Parsing.GeneralPrimitives.Token;
import Parsing.LineParsers.LineToParse;
import Parsing.TBPrims.SaveToken.ImpliedStringKind;


// XColumnDecl =  colname (kind | impliedStringKind) ;
// colname = name | quotedString;
// 

public class XColumn extends Pattern {
    /** Standard constructor */
    public XColumn () {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public XColumn(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Choose1(new Name(), new QuotedString()),             // colname
             new Choose1( new ColonKind(), new ImpliedStringKind() )  // kindname
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public Token klone(LineToParse l) {
        return new XColumn(l);
    }
    
}
