package Parsing.GeneralPrimitives.PrimTokens;

import Parsing.LineParsers.LineToParse;
import MDLUtilities.ParsE;
import Parsing.GeneralPrimitives.Token;

/** a NumBer is a sequence of [-](digit)+[.(digit)+] */
public class NatNumber extends Token {

    /** Standard constructor */
    public NatNumber() {
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public NatNumber(LineToParse l) {
        super(l);
    }

    @Override
    public boolean canParse() {
        toBeParsed.AssertNotAtEnd(this);
        char first = toBeParsed.charAt(0);
        char second = toBeParsed.charAt(1);
        if (first=='-' && toBeParsed.isDigit(second))
            return true;
        return toBeParsed.isDigit(first);
    }

   
    @Override
    public void consumeToken() {
        boolean oneDigitParsed = false;
        int i;
        char c = toBeParsed.peek();
        boolean positive = !toBeParsed.isNegative(c);
        int start = positive ? 0 : 1;
        for (i = start; i < toBeParsed.toParse.length(); i++) {
            c = toBeParsed.charAt(i);
            if (!toBeParsed.isDigit(c)) 
                break;
            oneDigitParsed= true;
        }
        if (!oneDigitParsed)
            throw ParsE.toss(ParsE.parseIllformedNumber,toBeParsed.lineno, toBeParsed.toParse );
        toBeParsed.returnSave(i);
    } 
    
    @Override
    public void parse() {
        toBeParsed.parseSave(this);
    }
    
    @Override
    public NatNumber klone(LineToParse l) {
        return new NatNumber(l);
    }
    
    @Override
    public String getEmsg() { return "integer"; }
}
