package Parsing.GeneralPrimitives.SaveTokens;

import Parsing.LineParsers.LineToParse;

/** Yuml token "" */
public class Nothing extends FixedStringToken {
    public static final String result = "(empty)";
    public static final String tok = "";
    
    /** Standard constructor */
    public Nothing() {
        super(true);
    }
    
    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public Nothing(LineToParse l) {
        super(l,true);
    }

    @Override
    public String getEmsg() {
        return result;
    }

    @Override
    public String getTokenString() {
        return tok;
    }
    
    @Override
    public boolean canParse() {
        return true;
    }
    
    @Override
    public void parse() {
        toBeParsed.add2ParseList(result);
    }

    @Override
    public Nothing klone(LineToParse l) {
       return new Nothing(l);
    }
}
