package Parsing.TBPrims.Lists;

import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.NonEmptyList;
import Parsing.LineParsers.LineToParse;
import Parsing.TBPrims.Patterns.FuncType;

/** a ExprList is FuncType (,FuncType)* */
public class FuncTypeList extends NonEmptyList { // comma separated names
    
    /** Standard constructor */
    public FuncTypeList() {
        super(new FuncType(), new Comma(), true);
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public FuncTypeList(LineToParse l) {
        super( new FuncType(), new Comma(), l, true);
    }

    @Override
    public FuncTypeList klone(LineToParse l) {
        return new FuncTypeList(l);
    }

}
