package Parsing.TBPrims.Patterns;

import Parsing.TBPrims.Lists.ExprList;
import Parsing.TBPrims.SaveToken.RightParenPush;
import Parsing.DBPrimitives.FixedStrTokens.LeftParen;
import Parsing.GeneralPrimitives.Optionals.Optional;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;

/**
 * function call arguments '(' ExprList ')' (last is push)
 */
public class Args extends Pattern {

    /**
     * Standard constructor
     */
    public Args() {
        super();
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public Args(LineToParse l) {
        super(l);
    }

    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = {new LeftParen(), new Optional( new ExprList() ), new RightParenPush()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public Args klone(LineToParse l) {
        return new Args(l);
    }
}
