package Parsing.TBPrims.Patterns;

import Parsing.TBPrims.SkipTokens.Colon;
import Parsing.TBPrims.SaveToken.Equals;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * axiom statement: name ':' expr '=' expr .
 */
public class AxiomStmt extends Pattern {


    /** Standard constructor */
    public AxiomStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public AxiomStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
           Token[] s = 
           {new Name(), new Colon(), new Expr(), new Equals(), 
            new Expr(), new Dot(), new End() };
           sequence = s;
        }
        return sequence;
    }

    @Override
    public AxiomStmt klone(LineToParse l) {
        return new AxiomStmt(l);
    }
}
