package Parsing.TBPrims.Patterns;

import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;
import Parsing.TBPrims.SaveToken.Option;
import Parsing.TBPrims.SaveToken.TaBleModifier;
import Parsing.TBPrims.SkipTokens.NothingNess;

/**
 * function type is a modified name  :- choose1('option', 'table', (empty)) name
 */
public class FuncType extends Pattern {

    /**
     * Standard constructor
     */
    public FuncType() {
        super();
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public FuncType(LineToParse l) {
        super(l);
    }

    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = {new Choose1(new Option(), new TaBleModifier(), new NothingNess()),  //<-- replace with Nothing in new version
                        new Name(),   // colname
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public FuncType klone(LineToParse l) {
        return new FuncType(l);
    }
}
