package Parsing.TBPrims.Patterns;

import Parsing.TBPrims.SkipTokens.Colon;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * Konstraint statement: name ':' expr '.'
 */
public class KonsStmt extends Pattern {

    /** Standard constructor */
    public KonsStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public KonsStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
           Token[] s = 
           {new Name(), new Colon(), new Expr(), new Dot(), new End() };
           sequence = s;
        }
        return sequence;
    }

    @Override
    public KonsStmt klone(LineToParse l) {
        return new KonsStmt(l);
    }
}
