package Parsing.TBPrims.Patterns;

import Parsing.TBPrims.SkipTokens.TBToken;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * spec statement: spec name.
 */
public class TBStmt extends Pattern {

    /** Standard constructor */
    public TBStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public TBStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
       if (sequence == null) {
           Token[] s = 
           {new TBToken(), new Name(), new Dot(), new End()};      
            sequence = s;
        }
        return sequence;
    }

    @Override
    public TBStmt klone(LineToParse l) {
        return new TBStmt(l);
    }

}
