package Parsing.TBPrims.SaveToken;

import Parsing.GeneralPrimitives.SaveTokens.*;
import Parsing.LineParsers.LineToParse;
import PrologDB.PrimType;

/** Yuml token "" */
public class ImpliedStringKind extends FixedStringToken {
    public static final String tok = "";
    
    /** Standard constructor */
    public ImpliedStringKind() {
        super(true);
    }
    
    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public ImpliedStringKind(LineToParse l) {
        super(l,true);
    }

    @Override
    public String getEmsg() {
        return Nothing.tok + " " + PrimType.Str.getName();
    }

    @Override
    public String getTokenString() {
        return tok;
    }
    
    @Override
    public void parse() {
        toBeParsed.add2ParseList(Nothing.result);
        toBeParsed.add2ParseList(PrimType.Str.getName());
    }

    @Override
    public ImpliedStringKind klone(LineToParse l) {
       return new ImpliedStringKind(l);
    }
}
