package Parsing.TBPrims.SaveToken;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * a Colon is ":" token which is saved (super(true);)
 */
public class IsVariable extends FixedStringToken {

    public static final String tok = "";
    public static final String IsVar = "@";

    /**
     * Standard constructor
     */
    public IsVariable() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public IsVariable(LineToParse l) {
        super(l, true);
    }

    @Override
    public boolean canParse() { // always true as the token is invisible
        return true;
    }

    @Override
    public void consumeToken() { // do nothing as there is no physical token
    }

    @Override
    public void parse() {
        toBeParsed.add2ParseList(IsVar);
    }

    @Override
    public String getTokenString() { // likely never called
        return IsVar;
    }

    @Override
    public IsVariable klone(LineToParse l) {
        return new IsVariable(l);
    }

    @Override
    public String getEmsg() {  // likely never called
        return "IsVariableMarker";
    }
}
