package Parsing.TBPrims.SaveToken;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * an Equals is "=" token
 */
public class Option extends FixedStringToken {

    public static final String tok = "option";
    public static final int toklen = tok.length();

    /**
     * Standard constructor
     */
    public Option() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public Option(LineToParse l) {
        super(l, true);
    }

    @Override
    public void consumeToken() {
        toBeParsed.returnSave(toklen);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public Option klone(LineToParse l) {
        return new Option(l);
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
