package Parsing.YumlPrimitives.FixedSave;

import Parsing.LineParsers.LineToParse;
import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;

/**
 * Yuml token: Solid is "-"
 */
public class Dashed extends FixedStringToken {

    public static final String tok = "-.-";

    /**
     * Standard constructor
     */
    public Dashed() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public Dashed(LineToParse l) {
        super(l, true);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public Dashed klone(LineToParse l) {
        return new Dashed(l);
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
