package Parsing.YumlPrimitives.FixedSave;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * Yuml token less-than
 */
public class Lss extends FixedStringToken {

    public static final String tok = "<";

    /**
     * Standard constructor
     */
    public Lss() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public Lss(LineToParse l) {
        super(l, true);
    }

    @Override
    public String getEmsg() {
        return tok;
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public Lss klone(LineToParse l) {
        return new Lss(l);
    }
}
