package Parsing.YumlPrimitives.Patterns;

import Parsing.YumlPrimitives.Patterns.BarrierBoxEntry;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;
import Parsing.DBPrimitives.FixedStrTokens.LeftBracket;
import Parsing.DBPrimitives.FixedStrTokens.RightBracket;
import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.SaveTokens.Nothing;
import Parsing.GeneralPrimitives.Token;
import Parsing.YumlPrimitives.BoxEntry;

/** Yuml Production : Box = ['name [,qs] [,qs] ']'*/
public class Box extends Pattern {
    
    /** Standard constructor */
    public Box() {
        super();
    }
    
    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public Box(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            { new LeftBracket(), new BoxEntry(), 
              new Choose1( new BarrierBoxEntry(), new Nothing() ), 
              new Choose1( new BarrierBoxEntry(), new Nothing() ),
              new RightBracket(), };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public Box klone(LineToParse l) {
        return new Box(l);
    }
}
