package Parsing.YumlPrimitives.Patterns;

import Parsing.YumlPrimitives.Patterns.Box;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;
import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.SaveTokens.Nothing;
import Parsing.GeneralPrimitives.Token;
import Parsing.YumlPrimitives.FixedSave.Dashed;
import Parsing.YumlPrimitives.Choose.End1;
import Parsing.YumlPrimitives.Choose.End2;
import Parsing.YumlPrimitives.Role;
import Parsing.YumlPrimitives.FixedSave.Solid;

/**
 * Yuml Production : Connect = [End1] [name] Solid [name] {End2] Box
 */
public class Connect extends Pattern {

    /**
     * Standard constructor
     */
    public Connect() {
        super();
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public Connect(LineToParse l) {
        super(l);
    }

    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s
                    = { new Choose1(new End1(), new Nothing()),
                        new Choose1(new Role(), new Nothing()),
                        new Choose1(new Dashed(), new Solid()),
                        new Choose1(new Role(), new Nothing()),
                        new Choose1(new End2(), new Nothing()),
                        new Box()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public Connect klone(LineToParse l) {
        return new Connect(l);
    }
}
