package Boot.MDELite;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

public class vpl2schemaTest {

    static final String Correct = "test/Boot/MDELite/Correct/";
    static final String errorFile = "trash/error.txt";
    static final String outFile = "trash/outFile.ooschema.pl";

    public vpl2schemaTest() {
    }

    @BeforeClass
    public static void setUpClass() {
    }

    @Before
    public void setUp() {
    }

    public void isCorrect(String filename) {
        RegTest.Utility.redirectStdOut(errorFile);
        try {
            vpl2OOSchema.main(Correct + filename + ".vpl.pl", outFile);
            RegTest.Utility.validate(outFile, Correct + filename + ".ooschema.pl", false);
            return;
        } catch (Exception e) {
            System.err.println(e.getMessage());
            fail();
        }
    }

    public void isWrong(String filename) {
        RegTest.Utility.redirectStdOut(errorFile);
        try {
            vpl2OOSchema.main(Correct + filename + ".vpl.pl");
            fail();
            return;
        } catch (Exception e) {
            RegTest.Utility.validate(errorFile, Correct + filename + ".txt", false);
        }
    }

    @Test
    public void nodeEdge1() {
        isWrong("nodeEdge1");
    }

    @Test
    public void nodeEdge2() {
        isCorrect("nodeEdge2");
    }

    @Test
    public void nodeEdge3() {
        isCorrect("nodeEdge3");
    }

    @Test
    public void abcd1() {
        isWrong("abcd1");
    }

    @Test
    public void abcd2() {
        isCorrect("abcd2");
    }

    @Test
    public void violet1() {
        isCorrect("violet1");
    }

}
