package BuildDocumentation;

import MDLUtilities.DocumentGenerator;
import java.io.File;
import java.io.PrintStream;
import org.junit.BeforeClass;
import org.junit.Test;

public class BuildDocTest extends DocumentGenerator {
    static String trash = "trash/";
    
    @BeforeClass
    public static void setUpClass() {
        new File("Docs").mkdir();
        MDL.OO2DBSchema.main("test/BuildDocumentation/test/school.ooschema.pl",
                           "test/BuildDocumentation/test/school.schema.pl");
    }
    
    @Test
    public void tableAggregation() {
        main("DocGen/TableAggregation.htm", "Docs/TableAggregation.html", "test/PrologDB/AggregationTest.java");
    }
    
    @Test
    public void m2m() {
        main("DocGen/M2MTemplate.htm", "Docs/M2MPrograms.html", "test/DML/PrologDB/DocExamplesTest.java");
    }

    @Test
    public void constraints() {
        main("DocGen/ConstraintTemplate.htm", "Docs/ConstraintPrograms.html", "test/DML/PrologDB/DocConstraintExamplesTest.java");
    }

    @Test
    public void families() {
        main("DocGen/FamiliesDemo.htm", "Docs/FamiliesDemo.html", "src/LectureExamples/FamiliesM2M.java");
    }

    @Test
    public void violet() {
        violetSetup();
        main("DocGen/VioletManualTemplate.htm", "Docs/VioletManual.html", "test/DML/PrologDB/DocConstraintExamplesTest.java");
    }

    void violetSetup() {
        Violett.ClassParser.main("test/BuildDocumentation/Test/StudentCourse.class.violet", trash+"outViolet.txt");
    }

    @Test
    public void yuml() {
        yumlSetup();
        main("DocGen/YumlManualTemplate.htm", "Docs/YumlManual.html", "");
    }

    void yumlSetup() {
        Yuml.ClassParser.main("test/BuildDocumentation/Test/x.yuml.yuml", trash+"outYuml1.txt");
        Yuml.ClassParser.main("test/BuildDocumentation/Test/y.yuml.yuml", trash+"outYuml2.txt");
    }

    @Test
    public void manual() throws Exception {
        manualSetup();
        main("DocGen/MDELiteOverviewTemplate.htm", "Docs/MDELiteOverview.html", "");
    }

    void manualSetup() throws Exception {
        PrintStream save = System.out;
        System.setOut(new PrintStream(trash+"outMan.txt"));
        schoolConform.main("test/BuildDocumentation/test/my.school.pl");
        System.setOut(save);
    }

    @Test
    public void rb() throws Exception {
        main("DocGen/M2TTemplate.htm", "Docs/M2TOverview.html", "test/RunningBear/demo.java");
    }

    @Test
    public void boot() throws Exception {
        main("DocGen/BootStrappingTemplate.htm", "Docs/BootStrapping.html", "test/Boot/MDELite/catalinaTest.java");
    }
    
    @Test
    public void docgen() throws Exception {
        main("DocGen/DocGenTemplate.htm", "Docs/DocGen.html", "");
    }
    
    @Test
    public void cd2schema() throws Exception {
        main("DocGen/Violet2OOSchemaTemplate.htm", "Docs/Violet2OOSchema.html", "");
    }
    
//    @Test
//    public void tb() throws Exception {
//        main("", "DocGen/TBTemplate.htm", "Docs/TB.html");
//    }
    
    @Test
    public void index() throws Exception {
        main("DocGen/indexTemplate.htm", "Docs/index.html", "");
    }

}
