package BuildDocumentation;

import PrologDB.*;

public class schoolConform {

    public static void main(String... args) {
        // Step 1: standard command-line processing
        MDLUtilities.Marquee4Conform mark = new MDLUtilities.Marquee4Conform(schoolConform.class, ".school.pl", args);
        String inputFileName = mark.getInputFileName();
        String AppName = mark.getAppName();  
             // if "X.school.pl" is input database name
             // then AppName = "X"

        // Step 2: open database to be validated + get needed tables
        DB db = DB.read(inputFileName);
        Table person = db.getTableEH("person");
        ErrorReport er = new ErrorReport();

        // Step 3: now perform database checks
        
        // 3a. Person Name Constraint
        person.select(t -> checkCharacter(t))
                .forEach(t -> er.add("Person name not capitalized: %s", t.get("name")));

        // 3b. Name Uniqueness Contraint
        person.select(t -> person.select(g -> g.get("name").equals(t.get("name"))).count() > 1)
                .forEach(t -> er.add("Persons with duplicate name : %s" + t.get("name")));

        // print error report 
        er.print(System.out);
    }
    
    static boolean checkCharacter(Tuple t) {
        String n = t.get("name");
        if (n.length() == 0) {
            return true;
        }
        Character c = n.charAt(0);
        return Character.isLowerCase(c);
    }
}
