package DML.SchemaTests;

import PrologDB.DBSchema;
import RegTest.Utility;
import java.io.File;
import org.junit.Test;

public class SchemaErrorsTest extends CommonTst {
    static final String testdata = "test/DML/SchemaTests/TestData/";
    static final String correct  = "test/DML/SchemaTests/Correct/";
    static final String errorfile = "trash/error.txt";

    public SchemaErrorsTest() {
    }

    protected void genericError(String localSchemaName) {
        String inputFile = testdata + localSchemaName;
        String correctFile = correct + localSchemaName;
        try {
            File schemafile = new File(inputFile);
            Utility.redirectStdOut(errorfile);
            DBSchema.read(schemafile);
        } catch (Exception e) {
            System.out.print(e.getMessage());
        }
        Utility.validate(errorfile, correctFile, false);
    }

    @Test
    public void test1() {
        genericError("ERRcomplex.schema.pl");
    }
    
    @Test
    public void test2() {
        genericError("ERRvioletdb.schema.pl");
    }
    
    @Test
    public void test3() {
        genericError("ERRinh.schema.pl");
    }
    
    @Test
    public void test4() {
        genericError("ERRhierarchy.schema.pl");
    }
    
    @Test
    public void test5() {
        genericError("ERRhierarchy2.schema.pl");  // no errors to detect
    }
    
    @Test
    public void test6() {
        genericError("ERRcomplex2.schema.pl");
    }
    
    @Test
    public void test7() {
        genericError("ERRcomplex3.schema.pl");
    }
}
