package Allegory.Alleg;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Dept extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Dept"; }

    public <TABLE> TABLE applyDept(Function<Dept,TABLE> f) { return f.apply(this); }

    public String name;
    public String city;
    public Div inDiv;
    protected String _inDiv;  // needed by database loader

    public Dept(String id, String name, String city, Div inDiv) {
       this.id = id;
       this.name = name;
       this.city = city;
       this.inDiv = inDiv;
    }

    // constructors used in database loading
    protected Dept() {}

    public Dept(String id, String name, String city) {
       this.id = id;
       this.name = name;
       this.city = city;
       this.inDiv = null;
    }

    private Dept initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       city = t.get("city");
       _inDiv = t.get("inDiv");
       return this;
    }

    public static Dept make(Tuple t) {
       return new Dept().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_inDiv.equals("null"))
           inDiv = db.Div.getTuple(_inDiv,er);
    }
    // end of methods used for loading a database

    static final String fmt = "Dept(%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name,q(city),__(inDiv));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name,q(city),__(inDiv));
    }

    public EmpTable employs() {
       EmpTable result = new EmpTable(db);
       for(Job r : db.Job.tuples()) {
          if(r.worksin==this && !result.contains(r.employs)) {
             result.add(r.employs);
          }
       }
       return result; // nmleft
    }

    public DivTable inDiv() {
       return new DivTable(db,this.inDiv);
    }  // diamondleft

    public Div link2inDiv() {
       return this.inDiv;
    }  // diamondleft

}
