package Allegory.Alleg;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Emp extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Emp"; }

    public <TABLE> TABLE applyEmp(Function<Emp,TABLE> f) { return f.apply(this); }

    public String name;
    public int age;

    public Emp(String id, String name, int age) {
       this.id = id;
       this.name = name;
       this.age = age;
    }

    // constructors used in database loading
    protected Emp() {}

    private Emp initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       age = t.getInt("age");
       return this;
    }

    public static Emp make(Tuple t) {
       return new Emp().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database


    public int age() {
       return age;
    }
    static final String fmt = "Emp(%s,%s,%d).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name,age);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name,age);
    }

    public EmpTable chldOf() {
       EmpTable result = new EmpTable(db);
       for(Anc r : db.Anc.tuples()) {
          if(r.parOf==this && !result.contains(r.chldOf)) {
             result.add(r.chldOf);
          }
       }
       return result; // nmleft
    }

    public EmpTable parOf() {
       EmpTable result = new EmpTable(db);
       for(Anc r : db.Anc.tuples()) {
          if(r.chldOf==this && !result.contains(r.parOf)) {
             result.add(r.parOf);
          }
       }
       return result; // nmleft
    }

    public DeptTable worksin() {
       DeptTable result = new DeptTable(db);
       for(Job r : db.Job.tuples()) {
          if(r.employs==this && !result.contains(r.worksin)) {
             result.add(r.worksin);
          }
       }
       return result; // nmleft
    }

}
