package Allegory.startrek;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.startrek.Lang.*;

public class crewmanTable extends TaBle<Database,crewman,crewmanTable> {
    @Override
    public String TupleTypeName() { return "crewman"; }

    public <TABLE> TABLE applycrewman(Function<crewmanTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public crewmanTable(Database db) {
        this(db,null);
    }

    public crewmanTable(Database db, crewman t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static crewmanTable BaseRelation(Database db) {
        crewmanTable tab = new crewmanTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<crewman> tuples() {
        if (computedTable)
            return tuples;
        LinkedList<crewman> all = new LinkedList<>();
        all.addAll(tuples);
        all.addAll(db.officer.tuples());
        all.addAll(db.medical.tuples());
        return all;
    }

    @Override
    public crewmanTable New() { return new crewmanTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       crewman r = new crewman(t.get("id"),t.get("fname"),t.get("lname"),t.get("species"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(crewman t) {
       if (computedTable) return false;
       if (t instanceof officer) return db.officer.delete((officer) t);
       if (t instanceof medical) return db.medical.delete((medical) t);
       return false;
    }

    @Override
    public void cascadingDeleteLocal(crewman t) {
       db.asg.select(x->x.hasCrew==t).delete(); //b6
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(crewman,[id,'fname','lname',species]).");
    }

    @Override
    public String pformat() { return crewman.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0;
       for (crewman a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fname).length()+2);
          f2 = Math.max(f2,(""+a.lname).length()+2);
          f3 = Math.max(f3,(""+a.species).length()+2);
       }
       return String.format("crewman(!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fname)));
       return st;
    }

    public STRINGTable lname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.lname)));
       return st;
    }

    public STRINGTable species() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.species)));
       return st;
    }

    public postTable onBoard() {
       LinkedList<crewman> tups = tuples();
       postTable result = new postTable(db);
       for(asg r : db.asg.tuples()) {
          if(tups.contains(r.hasCrew) && !result.contains(r.onBoard)) {
             result.add(r.onBoard);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   public officerTable toOfficerTable() {
      officerTable tb = new officerTable(db);
      for (crewman t : tuples()){ if (t instanceof officer) tb.add((officer) t); }
      return tb;
   }

   public medicalTable toMedicalTable() {
      medicalTable tb = new medicalTable(db);
      for (crewman t : tuples()){ if (t instanceof medical) tb.add((medical) t); }
      return tb;
   }

   /* end of filtering methods */

}
