package Allegory.startrek;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;

public class commander extends crewman {
    @Override
    public String TupleTypeName() { return "commander"; }

    public <TABLE> TABLE applycommander(Function<commander,TABLE> f) { return f.apply(this); }

    public String rank;

    public commander(String id, String fname, String lname, String species, starship onBoard, String rank) {
       this.id = id;
       this.fname = fname;
       this.lname = lname;
       this.species = species;
       this.onBoard = onBoard;
       this.rank = rank;
    }

    // constructors used in database loading
    protected commander() {}

    public commander(String id, String fname, String lname, String species, String rank) {
       this.id = id;
       this.fname = fname;
       this.lname = lname;
       this.species = species;
       this.onBoard = null;
       this.rank = rank;
    }

    private commander initFields(Tuple t) {
       id = t.get("id");
       fname = t.get("fname");
       lname = t.get("lname");
       species = t.get("species");
       _onBoard = t.get("onBoard");
       rank = t.get("rank");
       return this;
    }

    public static commander make(Tuple t) {
       return new commander().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_onBoard.equals("null"))
           onBoard = db.starship.getTuple(_onBoard,er);
    }
    // end of methods used for loading a database

    static final String fmt = "commander(%s,%s,%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,q(fname),q(lname),species,__(onBoard),rank);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,q(fname),q(lname),species,__(onBoard),rank);
    }

}
