package Allegory.startrek;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.startrek.Lang.*;

//StartTab
public class crewmanTable extends TaBle<Database,crewman,crewmanTable> {

    // constructors for creating empty or singleton tables
    public crewmanTable(Database db) {
        this(db,null);
    }

    public crewmanTable(Database db, crewman t) {
        this.db = db;
        initTupleList(t);
    }
//StartTab
    // methods for loading a database
    static crewmanTable BaseRelation(Database db) {
        crewmanTable tab = new crewmanTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<crewman> tuples() {
        if (computedTable)
            return tuples;
        LinkedList<crewman> all = new LinkedList<>();
        all.addAll(tuples);
        all.addAll(db.commander.tuples());
        all.addAll(db.lieutenant.tuples());
        return all;
    }

    @Override
    public crewmanTable New() { return new crewmanTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       crewman r = new crewman(t.get("id"),t.get("fname"),t.get("lname"),t.get("species"));
       r._onBoard = t.get("onBoard");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(crewman t) {
       if (computedTable) return false;
       if (t instanceof commander) return db.commander.delete((commander) t);
       if (t instanceof lieutenant) return db.lieutenant.delete((lieutenant) t);
       return false;
    }

    @Override
    public void cascadingDeleteLocal(crewman t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(crewman,[id,'fname','lname',species,onBoard:starship]).");
    }

    @Override
    public String pformat() { return crewman.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0, f4=0;
       for (crewman a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fname).length()+2);
          f2 = Math.max(f2,(""+a.lname).length()+2);
          f3 = Math.max(f3,(""+a.species).length()+2);
          f4 = Math.max(f4,a.onBoard.id.length());
       }
       return String.format("crewman(!%ds,!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3,f4).replace("!","%");
    }

//GettersTab
    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fname)));
       return st;
    }

    public STRINGTable lname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.lname)));
       return st;
    }

    public STRINGTable species() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.species)));
       return st;
    }
//GettersTab

//FinalTab
    public starshipTable onBoard() {
       starshipTable result = new starshipTable(db);
       for (crewman w : tuples()) {
          if (!result.contains(w.onBoard))
              result.add(w.onBoard);
       }
       return result; // diamondLeft
    }
//FinalTab
   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   public commanderTable toCommanderTable() {
      commanderTable tb = new commanderTable(db);
      for (crewman t : tuples()){ if (t instanceof commander) tb.add((commander) t); }
      return tb;
   }

   public lieutenantTable toLieutenantTable() {
      lieutenantTable tb = new lieutenantTable(db);
      for (crewman t : tuples()){ if (t instanceof lieutenant) tb.add((lieutenant) t); }
      return tb;
   }

   /* end of filtering methods */

}
