package Allegory.startrek;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.startrek.Lang.*;

public class lieutenantTable extends TaBle<Database,lieutenant,lieutenantTable> {
    @Override
    public String TupleTypeName() { return "lieutenant"; }

    public <TABLE> TABLE applylieutenant(Function<lieutenantTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public lieutenantTable(Database db) {
        this(db,null);
    }

    public lieutenantTable(Database db, lieutenant t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static lieutenantTable BaseRelation(Database db) {
        lieutenantTable tab = new lieutenantTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<lieutenant> tuples() {
        return tuples;
    }

    @Override
    public lieutenantTable New() { return new lieutenantTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       lieutenant r = new lieutenant(t.get("id"),t.get("fname"),t.get("lname"),t.get("species"),t.get("specialty"));
       r._onBoard = t.get("onBoard");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(lieutenant t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(lieutenant t) {
       db.crewman.cascadingDeleteLocal((crewman) t); // delete crewman associations
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(lieutenant,[id,'fname','lname',species,onBoard:starship,specialty]).");
    }

    @Override
    public String pformat() { return lieutenant.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0, f4=0, f5=0;
       for (lieutenant a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fname).length()+2);
          f2 = Math.max(f2,(""+a.lname).length()+2);
          f3 = Math.max(f3,(""+a.species).length()+2);
          f4 = Math.max(f4,a.onBoard.id.length());
          f5 = Math.max(f5,(""+a.specialty).length()+2);
       }
       return String.format("lieutenant(!%ds,!%ds,!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3,f4,f5).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fname)));
       return st;
    }

    public STRINGTable lname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.lname)));
       return st;
    }

    public STRINGTable species() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.species)));
       return st;
    }

    public STRINGTable specialty() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.specialty)));
       return st;
    }

    public starshipTable onBoard() {
       starshipTable result = new starshipTable(db);
       for (lieutenant w : tuples()) {
          if (!result.contains(w.onBoard))
              result.add(w.onBoard);
       }
       return result; // diamondLeft
    }

   /* the following methods cast a subtable into a supertable */

   public crewmanTable toCrewmanTable() {
      crewmanTable tb = new crewmanTable(db);
      for (crewman t : tuples()) { tb.add((crewman) t); }
      return tb;
   }

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
