package Allegory.startrek;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class starship extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "starship"; }

    public <TABLE> TABLE applystarship(Function<starship,TABLE> f) { return f.apply(this); }

    public String name;
    public String type;

    public starship(String id, String name, String type) {
       this.id = id;
       this.name = name;
       this.type = type;
    }

    // constructors used in database loading
    protected starship() {}

    private starship initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       type = t.get("type");
       return this;
    }

    public static starship make(Tuple t) {
       return new starship().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "starship(%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name,type);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name,type);
    }

    public crewmanTable hasCrew() {
       crewmanTable result = new crewmanTable(db);
       for(crewman a : db.crewman.tuples()) {
          if(a.onBoard==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

}
