package Allegory.startrek;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.startrek.Lang.*;

public class starshipTable extends TaBle<Database,starship,starshipTable> {
    @Override
    public String TupleTypeName() { return "starship"; }

    public <TABLE> TABLE applystarship(Function<starshipTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public starshipTable(Database db) {
        this(db,null);
    }

    public starshipTable(Database db, starship t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static starshipTable BaseRelation(Database db) {
        starshipTable tab = new starshipTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<starship> tuples() {
        return tuples;
    }

    @Override
    public starshipTable New() { return new starshipTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       starship r = new starship(t.get("id"),t.get("name"),t.get("type"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(starship t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(starship t) {
       t.hasCrew().delete(); //b1
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(starship,[id,name,type]).");
    }

    @Override
    public String pformat() { return starship.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (starship a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.name).length()+2);
          f2 = Math.max(f2,(""+a.type).length()+2);
       }
       return String.format("starship(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable name() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.name)));
       return st;
    }

    public STRINGTable type() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.type)));
       return st;
    }

    public crewmanTable hasCrew() {
       LinkedList<starship> tups = tuples();
       crewmanTable result = new crewmanTable(db);
       for(crewman a : db.crewman.tuples()) {
          if(tups.contains(a.onBoard) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
