package DBXlate.DBTranslators;

import PrologDB.*;
import MDLUtilities.Marquee1In_1Out;

public class borba1to2 {

   static String StrOfTargetSchema = "dbase(borba2,[bank,account,customer,savAcc,chAcc,bc]).\n"+
"\n"+
"table(bank,[id]).\n"+
"abs_table(account,[id,owner:customer]).\n"+
"table(customer,[id]).\n"+
"table(savAcc,[id,owner:customer,id,ofsavAcc:bank]).\n"+
"table(chAcc,[id,owner:customer,id,ofchAcc:bank]).\n"+
"table(bc,[id,banks:bank,custs:customer]).\n"+
"\n"+
"subtable(account,[savAcc,chAcc]).\n"+
"";

   static String copy[] = { "bank", "customer", "bc", };

   public static void main(String... args) {
      // Step 0: marquee processing
      Marquee1In_1Out mark = new Marquee1In_1Out(borba1to2.class, ".borba1.pl", ".borba2.pl", args);
      String inputDBname = mark.getInputFileName();
      String outputDBname = mark.getOutputFileName();
      String AppName = mark.getAppName();

      DB idb = DB.read(inputDBname);
      DBSchema targetSchema = DBSchema.read("borba2",StrOfTargetSchema);
      DB odb = new DB(AppName,targetSchema);

      Table otab, itab;
      for (String s : copy) {
         otab = odb.getTableEH(s);
         itab = idb.getTableEH(s);
         for (Tuple ti : itab.tuples()) {
            Tuple to = new Tuple(otab);
            to.copy(ti);
            otab.add(to);
         }
      }

      // special

      otab = odb.getTable("chAcc");
      itab = idb.getTable("chAcc");
      for (Tuple ti : itab.tuples()) {
         Tuple to = new Tuple(otab);
         String[] vals = ti.getValues();
         to.setValues(vals);
         otab.add(to);
      }

      otab = odb.getTable("savAcc");
      itab = idb.getTable("savAcc");
      for (Tuple ti : itab.tuples()) {
         Tuple to = new Tuple(otab);
         String[] vals = ti.getValues();
         to.setValues(vals);
         otab.add(to);
      }

      // end spcial


      odb.print(outputDBname);
      System.out.format(" database %s translated to %s\n",inputDBname,outputDBname);
   }
}

