package M4;

import MDLUtilities.Marquee1In_1Out;
import MDLUtilities.RunningBear;
import static MDLUtilities.RunningBear.RBSetup;
import PrologDB.Column;
import PrologDB.DB;
import PrologDB.PrimType;
import PrologDB.Table;
import PrologDB.Tuple;
import java.util.List;

public class CD2HTML extends RunningBear {

    static String outputFileName;

    public static void main(String... args) {
        Marquee1In_1Out mark = new Marquee1In_1Out(CD2HTML.class, ".cd.pl", ".class.html", args);
        RBSetup(mark, args);
        outputFileName = mark.getOutputFileName();

        DBHeader2Html(db);
        for (Table tab : db.getTables()) {
            Table2HTML(tab);
        }
        Footer();
        closeOut();
        System.err.format("file %s produced\n", outputFileName);
    }

    public static void DBHeader2Html(DB db) {
        l("<!DOCTYPE html>");
        l("<html>");
        l("<head>");
        l("<meta id=\"_moz_html_fragment\">");
        l("</head>");
        l("<body>");
        l("<span style=\"font-family: Helvetica,Arial,sans-serif;\">Database ");
        l("<span style=\"font-weight: bold;\">%s</span>;</span>", db.getName());
        l("<br style=\"font-family: Helvetica,Arial,sans-serif;\">");
        l("<br style=\"font-family: Helvetica,Arial,sans-serif;\">");
        String pngName = outputFileName.replace("class.html", "class.png");
        l("<img src=\"../%s\"><br>", pngName);
        l("<small/>");
    }

    public static void Table2HTML(Table t) {
        l("<span style=\"font-family: Helvetica,Arial,sans-serif;\">Table ");
        l("<span style=\"font-weight: bold;\">%s</span>;</span>", t.getName());
        l("<br style=\"font-family: Helvetica,Arial,sans-serif;\">");
        l("<table style=\"text-align: left font-family: Helvetica,Arial,sans-serif;\" ");
        l("border=\"1\" cellpadding=\"1\" cellspacing=\"1\">");
        l("<tbody>");
        l("<tr>");
        for (Column c : t.getTableSchema().getColumns()) {
            l("<td style=\"vertical-align: top;\"><span style=\"font-weight: bold;\"><small>%s</small></span><br></td>", c.getName());
        }

        for (Tuple r : t.tuples()) {
            tuple2html(t, r);
        }
        l("</tbody>");
        l("</table>");
        l("<br style=\"font-family: Helvetica,Arial,sans-serif;\">");
    }

    static void tuple2html(Table t, Tuple r) {
        List<Column> cols = t.getTableSchema().getColumns();
        String tableName = t.getName();
        String[] values = r.getValues();
        l("<tr>");
        for (Column c : cols) {
            String s = r.get(c);
            // 3 possibilities: id (create anchor), prim value (print), foreign key (link to anchor)
            if (c.getName().equals("id")) {
                l("<td style=\"vertical-align: top;\"><small><a name=\"%s_%s\"></a>%s</small><br></td>", tableName, s, s);
                continue;
            }
            String kind = c.getKind();
            if (PrimType.isPrim(kind)) {
                l("<td style=\"vertical-align: top;\"><small>%s</small><br></td>", s);
                continue;
            }
            l("<td style=\"vertical-align: top;\"><small><a href=\"#%s_%s\">%s</small><br></td>",kind,s,s);
        }
        l("</tr>");
    }

    static void Footer() {
        l("</body>");
        l("</html>");
    }
}
