package M4;

import CD.CDConform;
import CD.CDSpec;
import MDLUtilities.Marquee1In_1Out;
import PrologDB.DB;
import java.io.FileNotFoundException;


// translates a cdspec file into mdelite schema
// calling sequence <x.cdspec.pl> <x.schema.pl>
public class CDSpec2Schema  {
    public static String schemaEnd = ".schema.pl";
    public static String tmp = "tmp.cd.pl";

    public static void main(String... args) throws FileNotFoundException, Exception {
        // Step 1: standard marquee processing
        Marquee1In_1Out mark = new Marquee1In_1Out(CDSpec2Schema.class,CDSpec.cdspecEnd, schemaEnd, args);
        String inputFileName = mark.getInputFileName();
        String outputFileName = mark.getOutputFileName();
        
        // Step 2: straightline code
        CDSpec cd = CDSpec.read(inputFileName);
        DB cddb = cd.toCD();
        CDConform.check(cddb);
        cddb.print(tmp);
        
        CD.CD2Schema.main(tmp, outputFileName);
    }
}

