package M4;

import M4Utilities.SwingApp;
import MDLUtilities.Marquee2In_0Out;
import PrologDB.DB;
import PrologDB.Table;
import PrologDB.Tuple;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;

public class DisplayCDTable extends SwingApp {

    // REMEMBER -- all constants should be static
    // the following define the initial contents of both table models
    static String columnNames[] = {"Name", "Male", "Number", "Country"};

    static Object data[][] = {
        {"Boris", "true", "1", "Russia"},
        {"Natasha", "false", "2", "Ukraine"},
        {"Moose", "true", "3", "Canada"},
        {"Squirrel", "true", "4", "United States"},};

    // declare and initialize atomic components here
    JButton refresh;
    JTable t;
    DefaultTableModel tm;

    public void initAtoms() {
        refresh = new JButton("refresh table");
        tm = new DefaultTableModel(data, columnNames);
        t = new JTable(tm);

        // This is the screwy part about Tables -- 
        // by default their size is Dimension( 450, 400 ).
        // If you want anything else, you must set the size manually
        t.setPreferredScrollableViewportSize(new Dimension(450, 80));
    }

    // declare and initialize layout components here
    JPanel buttons;
    JScrollPane js;

    public void initLayout() {
        buttons = new JPanel();
        buttons.setLayout(new FlowLayout());
        buttons.setBorder(BorderFactory.createEtchedBorder());
        buttons.add(refresh);
        js = new JScrollPane(t);
    }

    // initialize ContentPane here
    public void initContentPane() {
        ContentPane = new JPanel();
        ContentPane.setLayout(new BoxLayout(ContentPane, BoxLayout.Y_AXIS));
        ContentPane.setBorder(BorderFactory.createEtchedBorder());
        ContentPane.add(buttons);
        ContentPane.add(js);
    }

    // initialize listeners here
    public void initListeners() {
        // when show31 button is pushed...

        refresh.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                loadDB();
                ContentPane.validate();
            }
        });

    }

    // place in this method any action for exiting application
    public void applicationExit() {
    }

    public DisplayCDTable() {
        super();
    }

    public DisplayCDTable(String AppTitle) {
        super(AppTitle);
    }

    static DB db;
    static String inputFileName, tableName, AppName;

    public static void main(String... args) {
        Marquee2In_0Out mark = new Marquee2In_0Out(DisplayCDTable.class, ".cd.pl", "table_name", args);
        inputFileName = mark.getInputFileName();
//        if (args.length != 2) {
//            mark.displayMarquee("");
//        }
        tableName = args[1];
        AppName = mark.getAppName();

        process(db, tableName);
    }

    //http://math.hws.edu/javanotes/c7/s5.html
    static void loadDB() {
        db = DB.read(inputFileName);
        Table tab = db.getTableEH(tableName);
        columnNames = tab.getTableSchema().getColumnNames();
        data = new String[tab.size()][];
        int i = 0;
        for (Tuple t : tab.tuples()) {
            data[i] = t.getValues();
            i++;
        }
    }

    static void process(DB db, String tableName) {
        loadDB();
        DisplayCDTable p = new DisplayCDTable(inputFileName);
        p.setVisible(true);
    }
}
