package M4Parsing.CDPrims.Patterns;

import M4Parsing.CDPrims.PrimTokens.Assoc;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.DBPrimitives.FixedStrTokens.LeftParen;
import Parsing.DBPrimitives.FixedStrTokens.RightParen;
import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * Assoc statement: assoc(id,end1,role1,key,end2,role2).
 */
public class AssocOld extends Pattern {

    /** Standard constructor */
    public AssocOld() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public AssocOld(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new LeftParen(), 
                new Name(), new Comma(), // Name of association
                new Name(), new Comma(), // Class1
                new Name(), new Comma(), // role1 (of class1)
                new CardOrName(), new Comma(), // type1
                new Name(), new Comma(), // Class2
                new Name(), new Comma(), // role2
                new CardOrName(),              // type2
                new RightParen(), new Dot(), new End()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public AssocOld klone(LineToParse l) {
        return new AssocOld(l);
    }
}
