package M4Parsing.CDPrims.Patterns;

import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * cardinality "int,int" or name "BLACK_DIAMOND,..."
 */
public class CardOrName extends Pattern {

    /** Standard constructor */
    public CardOrName() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public CardOrName(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Choose1( new Name(), new Card())};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public CardOrName klone(LineToParse l) {
        return new CardOrName(l);
    }
}
