package M4Parsing.PlantUMLPrims.Patterns;

import Parsing.GeneralPrimitives.Optionals.Optional;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * link PlantUML statement: NAME [quotedString] LeftTags Separator RightTags [quotedString] NAME [ ColonName ] end;
 *               LeftTags : LeftSuper | Association | Aggregation | Nothing;
 *               RightTags: RightSuper | Association | Aggregation | Nothing;
 *               ColonName: ":" NAME ;
 *               Separator: "--" | ".." ;
 */
public class FieldDecl extends Pattern {

    /** Standard constructor */
    public FieldDecl() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public FieldDecl(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {   new Name(), 
                new Optional( new ColonName() ),
                new End(),
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public FieldDecl klone(LineToParse l) {
        return new FieldDecl(l);
    }
}
