// SwingApp.java - Abstract program that defines the basic "shell"
// of a Swing Application. Specific Swing applications are subclasses
// of SwingApp

package M4Utilities;

import java.awt.event.*;
import javax.swing.*;

public class SwingApp extends JFrame {

   // declare atomic components here
   // initialize them in initAtoms()

   public void initAtoms() {};

   // declare layout components here
   // initialize them initLayout()

   public void initLayout() {};

   // declare and initialize inter-component-listeners here

   public void initListeners() {};

   // ContentPane is declared here
   // and is initialized in initContentPane()

   public JPanel ContentPane;

   public void initContentPane() {};

   // initialize entire containment hierarchy

   public void initHierarchy() {
      initAtoms();                       // initialize atoms
      initLayout();                      // initialize layout
      initListeners();                   // initialize listeners
      initContentPane();                 // initialize content pane
      getContentPane().add(ContentPane); // set content pane of window
   }

   // constructor that is useful for nesting hierarchies

   public SwingApp() {
      super();
      initHierarchy();
   }

   // constructor used for Swing applications

   public SwingApp( String AppTitle ) {
      super( AppTitle );	                 // set title
      initHierarchy();                   // initialize hierarchy
      addWindowListener(		             // standard code to kill window 
            new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
      pack();				             // start window by packing
      setVisible(true);                  // and making visible
   }

   // create an instance of this class in main to run application - ex:
   // public void static main(String args[]) {  
   //   new SubClassOfSwingApp("example Title");
   // }
}

