package Meta4Framework.A;

import java.util.function.Function;

/**
 * this aggregation function returns the designated column value of the first
 * tuple of a table. The table itself is assumed to be the result of a group by,
 * where all tuples have the same designated column value
 */
public class GroupValue<T> implements Reducer<T> {

    String agg;
    Function<T, String> val;

    public GroupValue(Function<T, String> val) {
        this.val = val;
        reset();
    }

    @Override
    public void add(T t) {
        agg = val.apply(t);
    }

    @Override
    public Object getAccumulated(int i) {
        return agg;
    }

    @Override
    public void reset() {
        agg = null;
    }

    @Override
    public int resultCount() {
        return 1;
    }
}
