package Meta4Framework.O;

import static PrologDB.PrimType.*;
import java.io.PrintStream;

public class OTuple {

    OTable belongsTo = null;
    Object[] values;

    public OTuple(Object... vals) {
        values = vals;
    }
    
    public OTuple(int size) {
        values = new Object[size];
        for (int i=0; i<size; i++) {
            values[i] = null;
        }
    }

    public Object get(int i) {
        return values[i];
    }

    private int getIndx(String colname) {
        int i = 0;
        for (OCol oc : belongsTo.cols) {
            if (oc.name.equals(colname)) {
                return i;
            }
        }
        throw new RuntimeException("No column with name " + colname + " in OTable " + belongsTo.name);
    }

    public Object get(String colname) {
        return values[getIndx(colname)];
    }

    public void set(String colname, Object v) {
        values[getIndx(colname)] = v;
    }
    
    public void set(int i, Object v) {
        values[i]=v;
    }

    public int size() {
        return values.length;
    }

    @Override
    public String toString() {
        String result = belongsTo.name + "(";
        String comma = "";
        int i = 0;
        for (OCol oc : belongsTo.cols) {
            switch (oc.getType()) {
                case Int:
                    result += comma + values[i];
                    break;
                case Bool:
                    result += comma + values[i];
                    break;
                case Str:
                    result += comma + values[i];
                    break;
                case QStr:
                    result += comma + "'" + values[i] + "'";
                    break;
                case Flt:
                    result += comma + values[i];
                    break;
                case Dbl:
                    result += comma + values[i];
                    break;
                default:
            }
            i++;
            comma = ",";
        }
        result += ").\n";
        return result;
    }

    
    public void print(PrintStream out) {
        out.print(this.toString());
    }

    public void print() {
        System.out.print(this.toString());
    }
}