package Meta4Framework;

import java.io.PrintStream;
import PrologDB.ErrorReport;

public abstract class TuPle<Database> extends CoMMoN<Database> {
    public String id;
    
    // error support and tuple comparison utilities
    
    public abstract String TupleTypeName();
    
    public int compareTo(TuPle<Database> p) {
        return id.compareTo(p.id);
    }
    
    // insertion, database load utilities
    
    public void setDB(Database db) {
        this.db = db;
    }
    
    public abstract void finishTuple(Database db, ErrorReport er);
    
    
    // printing utilities
    
    public void print(PrintStream out) {
        String s = this.toString();
        out.format(s);
    }
    
    public String q(String x) { return "'"+x+"'"; }   
        
    @Override
    public abstract String toString();
    
    public abstract String toString(String fmt);
    
    public void print() { 
        TuPle.this.print(System.out);
    }
    
    public void print(Object x) {
        System.out.print(x);
    }
    
    public void println(Object x) {
        System.out.println(x);
    }
    
    public void print(Object... x) {
        String result = "";
        String space = "";
        for (Object s : x) {
            result = result + space + s;
            space = " ";
        }
        TuPle.this.print(result);
    }
    
    public void println(Object... x) {
        print(x);
        System.out.println();
    }
    
    public String format(String fmt, Object... x) {
        return String.format(fmt,x);
    }
    
    public String formatln(String fmt, Object... x) {
        return format(fmt+"\n",x);
    }

}
