package CD;

import org.junit.Test;

public class CD2SchemaTest {

    static String trash = "trash/";
    static String testdata = "test/CD/TestData/";
    static String correct = "test/CD/Correct/";
    static String cdEnd = ".cd.pl";
    static String schemaEnd = ".schema.pl";
    static String errEnd = ".txt";

    public CD2SchemaTest() {
    }

    public void doit(String cd) {
        String infile = testdata + cd + cdEnd;
        String outfile = trash + cd + schemaEnd;
        String correctFile = correct + cd + schemaEnd;
        CD2Schema.main(infile, outfile);
        RegTest.Utility.validate(outfile, correctFile, false);
    }

    public void doitErr(String cd) {
        String infile = testdata + cd + cdEnd;
        String outfile = trash + cd + schemaEnd;
        String errfile = trash + cd + errEnd;
        String correctFile = correct + cd + errEnd;
        RegTest.Utility.redirectStdErr(errfile);
        try {
            CD2Schema.main(infile, outfile);
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
        RegTest.Utility.validate(errfile, correctFile, false);
    }

    @Test
    public void DPE() {
        doit("DPE");
    }
    
    @Test
    public void EDD() {
        doit("EDD");
    }

    @Test
    public void abcd2() {
        doit("abcd2");
    }

    @Test
    public void alleg() {  // does not have black diamond
        doit("alleg");
    }

    @Test
    public void dogOwner() {
        doit("dogOwner");
    }

    @Test
    public void nodeEdge2() {
        doit("nodeEdge2");
    }

    @Test
    public void nodeEdge3() {
        doit("nodeEdge3");
    }

    @Test
    public void starTrek() {  // does not have black diamond
        doit("starTrek");
    }

    @Test
    public void violet1() {   // does not have black diamond
        doit("violet1");
    }

    @Test
    public void wAbs() {
        doit("wAbs");
    }

}
