package LineParsers;

import M4Parsing.LineParsers.CDLineParsers;
import CD.CDSpec;
import CD.AssocSchema;
import PrologDB.ErrorReport;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author don
 */
public class AssocLineTest {

    public AssocLineTest() {
    }

    public void doit(String line, String output) {
        CDSpec os = new CDSpec("me");
        ErrorReport er = new ErrorReport();
        //parseAssocLine(String line, int lineno, Schema dbs, ErrorReport er)
        CDLineParsers.parseAssocLine(line, 5, os, er);
        for (AssocSchema as : os.getAssocSchemas()) {
            String s  = as.toString().trim();
            if (!output.trim().equals(s)) {
                fail();
            }
        }
    }

    public void doitErr(String line, String msg) {
        CDSpec os = new CDSpec("me");
        ErrorReport er = new ErrorReport();
        CDLineParsers.parseAssocLine(line, 5, os, er);
        String e= er.toString().trim();
        if (e.equals(msg))
            return;
        System.out.println(e);
        System.out.println(msg);
        fail();
    }

    @Test
    public void t1() {
        doit("assoc(left,leftrole, DIAMOND, right, rightrole,ml ).", 
                "assoc(left,leftrole,DIAMOND,right,rightrole,ml).");
    }

    @Test
    public void t2() {
        doit("assoc   (left,leftrole, BLACK_DIAMOND, right, rightrole,ty ).", 
                "assoc(left,leftrole,BLACK_DIAMOND,right,rightrole,ty).");
    }
    
    @Test
    public void t3() {
        doit("assoc   (left,leftrole, NM, right, rightrole,ty ).", 
                "assoc(left,leftrole,NM,right,rightrole,ty).");
    }

    @Test
    public void b1() {
        doitErr("assoc(a,b,c,d,e.f).", 
                "line 5: parse error 'comma' expected at >>.f).");
    }

    @Test
    public void b2() {
        doitErr("assoc(a,b,c,d)", 
                "line 5: parse error 'comma' expected at >>)");
    }
}
