package Allegory.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.Star.Lang.*;

public class WTable extends TaBle<Database,W,WTable> {
    @Override
    public String TupleTypeName() { return "W"; }

    public <TABLE> TABLE applyW(Function<WTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public WTable(Database db) {
        this(db,null);
    }

    public WTable(Database db, W t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static WTable BaseRelation(Database db) {
        WTable tab = new WTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<W> tuples() {
        return tuples;
    }

    @Override
    public WTable New() { return new WTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       W r = new W(t.get("id"),t.get("w1"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(W t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(W t) {
       db.wc.select(x->x.cw==t).delete(); //b6
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(W,[id,w1]).");
    }

    @Override
    public String pformat() { return W.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (W a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.w1).length()+2);
       }
       return String.format("W(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable w1() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.w1)));
       return st;
    }

    public CTable wc() {
       LinkedList<W> tups = tuples();
       CTable result = new CTable(db);
       for(wc r : db.wc.tuples()) {
          if(tups.contains(r.cw) && !result.contains(r.wc)) {
             result.add(r.wc);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
