package Allegory.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.Star.Lang.*;

public class YTable extends TaBle<Database,Y,YTable> {
    @Override
    public String TupleTypeName() { return "Y"; }

    public <TABLE> TABLE applyY(Function<YTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public YTable(Database db) {
        this(db,null);
    }

    public YTable(Database db, Y t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static YTable BaseRelation(Database db) {
        YTable tab = new YTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Y> tuples() {
        return tuples;
    }

    @Override
    public YTable New() { return new YTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Y r = new Y(t.get("id"),t.get("y1"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Y t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Y t) {
       db.yc.select(x->x.cy==t).delete(); //b6
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Y,[id,y1]).");
    }

    @Override
    public String pformat() { return Y.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (Y a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.y1).length()+2);
       }
       return String.format("Y(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable y1() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.y1)));
       return st;
    }

    public CTable yc() {
       LinkedList<Y> tups = tuples();
       CTable result = new CTable(db);
       for(yc r : db.yc.tuples()) {
          if(tups.contains(r.cy) && !result.contains(r.yc)) {
             result.add(r.yc);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
