package Parsing.PlantUMLPrims.Patterns;

import Parsing.LineParsers.LineToParse;
import M4Parsing.PlantUMLPrims.Patterns.FieldDecl;
import java.util.LinkedList;
import org.junit.Test;
import static org.junit.Assert.*;

public class PlantUMLFieldDeclTest extends PlantUMLCommon {

    public PlantUMLFieldDeclTest() {
        System.out.println("Running PlantUMLFieldDeclTest");
    }

    public void doit(String line, String... correct) {
        LinkedList<String> list = new LinkedList<>();
        LinkedList<String> result = makelist(correct);
        try {
            LineToParse l = new LineToParse(line, 1);
            FieldDecl st = new FieldDecl(l);
            st.parse();
            list = l.parseList;
        } catch (RuntimeException ex) {
            System.err.println(ex.getMessage());
            fail();
        }
        if (isEqual(result, list) == false) {
            System.err.format("%s != %s\n", listtoString(result), listtoString(list));
            System.err.println("output NEQ result");
            fail();
        }
    }
//    private LinkedList<String> makelist(String... x) {
//        LinkedList<String> result = new LinkedList<>();
//        for (String y : x) {
//            result.addLast(y);
//        }
//        return result;
//    }

//    private boolean isEqual(LinkedList<String> a, LinkedList<String> b) {
//        if (a.size() != b.size()) {
//            return false;
//        }
//        for (int i = 0; i < a.size(); i++) {
//            if (!a.get(i).equals(b.get(i))) {
//                return false;
//            }
//        }
//        return true;
//    }
//    public void doitErr(String line, String msg) {
//        try {
//            CDSchema os = CDLineParsers.parseClassDiagramLine(line, 5);
//        } catch(RuntimeException ex) {
//            String e = ex.getMessage().trim();
//            if (msg.trim().equals(e))
//                return;
//            System.out.println(e);
//            System.out.println(msg);
//        }
//        fail();
//    }
    @Test
    public void t1() {
        String[] result = {"flightNumber", "int"};
        doit("flightNumber : int", result);
    }

    @Test
    public void t2() {
        String[] result = {"departureTime", "string"};
        doit("departureTime : string", result);
    }

    @Test
    public void t3() {
        String[] result = {"departureTime", "qstring"};
        doit("departureTime : qstring", result);
    }

    @Test
    public void t4() {
        String[] result = {"departureTime"};
        doit("departureTime", result);
    }

    @Test
    public void t5() {
        String[] result = {"data"};
        doit("data", result);
    }

//
//    @Test
//    public void t2() {
//        doit("classDiagram     z     .     ", "z");
//    }
//    @Test 
//    public void b1() {
//        doitErr("classDiagam(x,[y,z,w]).",
//                "line 5: parse error 'classDiagram' expected at >>classDiagam(x,[y,z,w]).");
//    }
//    
//    @Test 
//    public void b2() { 
//        doitErr("classDiagram(z,[]).","line 5: parse error 'name' expected at >>(z,[]).");
//    }  
}
