package Parsing.PlantUMLPrims.Patterns;

import Parsing.PlantUMLPrims.Patterns.PlantUMLCommon;
import Parsing.LineParsers.LineToParse;
import M4Parsing.PlantUMLPrims.Patterns.LinkDecl;
import java.util.LinkedList;
import org.junit.Test;
import static org.junit.Assert.*;

public class PlantUMLLinkLine extends PlantUMLCommon {

    public PlantUMLLinkLine() {
    }

    public void doit(String line, String... correct) {
        LinkedList<String> list = new LinkedList<>();
        LinkedList<String> result = makelist(correct);
        try {
            LineToParse l = new LineToParse(line, 1);
            LinkDecl st = new LinkDecl(l);
            st.parse();
            list = l.parseList;
        } catch (RuntimeException ex) {
            System.err.println(ex.getMessage());
            fail();
        }
        if (isEqual(result, list)==false) {
            System.err.format("%s != %s\n", listtoString(result), listtoString(list));
            System.err.println("output NEQ result");
            fail();
        }
    }


//    public void doitErr(String line, String msg) {
//        try {
//            CDSchema os = CDLineParsers.parseClassDiagramLine(line, 5);
//        } catch(RuntimeException ex) {
//            String e = ex.getMessage().trim();
//            if (msg.trim().equals(e))
//                return;
//            System.out.println(e);
//            System.out.println(msg);
//        }
//        fail();
//    }
    
    @Test
    public void t1() {
        String[] result = {"Class01","^","--","(empty)","Class02"};
        doit("Class01 ^-- Class02", result);
    }
    
    @Test
    public void t2() {
        String[] result = {"Class03","*","--","(empty)","Class04"};
        doit("Class03 *-- Class04", result);
    }
    
    @Test
    public void t3() {
        String[] result = {"Class05","o","--","(empty)","Class06"};
        doit("Class05 o-- Class06", result);
    }
    
    @Test
    public void t4() {
        String[] result = {"Class07","(empty)","..","(empty)","Class08"};
        doit("Class07 .. Class08", result);
    }
    
    @Test
    public void t5() {
        String[] result = {"Class09","(empty)","--","(empty)","Class10"};
        doit("Class09 -- Class10", result);
    }
    
    @Test
    public void t6() {
        String[] result = {"Class11","^","..","(empty)","Class12"};
        doit("Class11 ^.. Class12", result);
    }
    
    @Test
    public void t9() {
        String[] result = {"Class17","(empty)","..","^","Class18"};
        doit("Class17 ..^ Class18", result);
    }
    
//    @Test
//    public void t10() {
//        String[] result = {"Class01","\"1\"","*","--","(empty)","many","Class02","contains"};
//        doit("Class01 \"1\" *-- \"many\" Class02 : contains", result);
//    }
//    
//    @Test
//    public void t11() {
//        String[] result = {"Class03","o","--","(empty)","Class04","aggreg"};
//        doit("Class03 o-- Class04 : aggreg", result);
//    }
    
    @Test
    public void t12() {
        String[] result = {"Class05","(empty)","--","*","1", "Class06"};
        doit("Class05 --* \"1\" Class06", result);
    }
    
    
//
//    @Test
//    public void t2() {
//        doit("classDiagram     z     .     ", "z");
//    }

//    @Test 
//    public void b1() {
//        doitErr("classDiagam(x,[y,z,w]).",
//                "line 5: parse error 'classDiagram' expected at >>classDiagam(x,[y,z,w]).");
//    }
//    
//    @Test 
//    public void b2() { 
//        doitErr("classDiagram(z,[]).","line 5: parse error 'name' expected at >>(z,[]).");
//    }  
}
