package PlantUml;

import CD.CD2PlantUML;
import org.junit.Test;


public class ClassUnParserTest extends Common.SharedDecls {
    static final String TestData = "test/PlantUml/TestData/";
    static final String Correct = "test/PlantUml/Correct/";
    
    public ClassUnParserTest() {
    }
    

    public void doit(String fileNameStub, boolean skipCDSpecTranslation)  {
        String inputFileName = TestData+fileNameStub+cdEnd;
        String outputFileName = Trash+fileNameStub+plantuml;
        String outputPngName = Trash+fileNameStub+pngEnd;
        
        if (skipCDSpecTranslation) {
            inputFileName = TestData+fileNameStub+cdEnd;
        }  else {
            M4.CDSpec2CD.main(TestData+fileNameStub+cdspecEnd, inputFileName);
        }
        
        CD2PlantUML.main(inputFileName, outputFileName);
        RegTest.Utility.validate(outputFileName, Correct+fileNameStub+plantuml, false);
        try {
            M4.PlantUML2Png.main(outputFileName,outputPngName);
            System.out.println("generated "+ outputPngName);
        } catch (Exception ex) {
            System.err.println("unable to generate "+ outputPngName);
        }
    }


    @Test
    public void Star() throws Exception {
        doit("Star",false);
    }
    
    @Test
    public void bigPrime() throws Exception {
        doit("bigPrime",true);
    }
    
    @Test
    public void alleg() throws Exception {
        doit("Alleg",false);
    }
    
    @Test
    public void Family() throws Exception {
        doit("Family",false);
    }
    
    @Test 
    public void Person() throws Exception {
        doit("Person",false);
    }
    
    @Test
    public void big() throws Exception {
        doit("big",false);
    }
}
