package Drivers.ATLExample;

import MDLUtilities.Marquee1In_1Out;
import Allegory.Person.*;

public class ATLExample {
    static Allegory.Family.Database in;
    static Allegory.Person.Database out;
    
    public static void main(String... args) {
        // Step 1: standard marquee processing
        Marquee1In_1Out mark = new Marquee1In_1Out(ATLExample.class,
                ".family.pl", ".person.pl", args);
        String inputFileName = mark.getInputFileName();

        // Step 2: read the families database and init output database
        in = new Allegory.Family.Database(inputFileName);
        out = new Allegory.Person.Database();
        
        // Step 3: m2m transformation + print out
        addBoys();
        addFathers();
        addGirls();
        addMothers();
        out.print();
    }

    static void addBoys() {
        in.member
          .select(m->m.sonOf!=null)
          .forEach(m->{ 
              String fullName = m.firstName+" "+m.sonOf.lastName;
              out.male.add(new male(m.id,fullName)); });
    }
    
    static void addGirls() {
        in.member
          .select(m->m.daughterOf!=null)
          .forEach(m->{ 
              String fullName = m.firstName+" "+m.daughterOf.lastName;
              out.female.add(new female(m.id,fullName)); });
    }
    
    static void addFathers() { 
        in.family.forEach(f->{ 
            String fullName =  f.fatherid.firstName + " " +f.lastName;
            if (out.male.select(m->m.fullName.equals(fullName)).size()==0)
               out.male.add(new male(f.fatherid.id, fullName));});
    }
    
    static void addMothers() { 
        in.family.forEach(f->{ 
            String fullName =  f.motherid.firstName + " " +f.lastName;
            if (out.female.select(m->m.fullName.equals(fullName)).size()==0)
               out.female.add(new female(f.motherid.id, fullName));});
    }
}

