package Drivers.ATLExample;

import MDLUtilities.Marquee1In_1Out;
import Allegory.Person.*;

public class PPExample {
    static Allegory.Family.Database indb;
    static Allegory.Person.Database outdb;
    
    public static void main(String... args) {
        // Step 1: standard marquee processing
        Marquee1In_1Out mark = new Marquee1In_1Out(PPExample.class,
                ".family.pl", ".person.pl", args);
        String inputFileName = mark.getInputFileName();

        // Step 2: read the families database and init output database
        indb = new Allegory.Family.Database(inputFileName);
        outdb = new Allegory.Person.Database();
        
        // Step 3: m2m transformation + print out
        addBoys();
        addFathers();
        addGirls();
        addMothers();
        outdb.prettyprint();
        System.out.println("--------------------------------");
        outdb.print();
    }

    static void addBoys() {
        indb.member
          .select(m->m.sonOf!=null)
          .forEach(m->{ 
              String fullName = m.firstName+" "+m.sonOf.lastName;
              outdb.male.add(new male(m.id,fullName)); });
    }
    
    static void addGirls() {
        indb.member
          .select(m->m.daughterOf!=null)
          .forEach(m->{ 
              String fullName = m.firstName+" "+m.daughterOf.lastName;
              outdb.female.add(new female(m.id,fullName)); });
    }
    
    static void addFathers() { 
        indb.family.forEach(f->{ 
            String fullName =  f.fatherid.firstName + " " +f.lastName;
            if (outdb.male.select(m->m.fullName.equals(fullName)).size()==0)
               outdb.male.add(new male(f.fatherid.id, fullName));});
    }
    
    static void addMothers() { 
        indb.family.forEach(f->{ 
            String fullName =  f.motherid.firstName + " " +f.lastName;
            if (outdb.female.select(m->m.fullName.equals(fullName)).size()==0)
               outdb.female.add(new female(f.motherid.id, fullName));});
    }
}

