
package Drivers.startrek;

import Allegory.startrek.Database;
import Allegory.startrek.crewman;
import Allegory.startrek.crewmanTable;
import PrologDB.ErrorReport;
import java.io.FileNotFoundException;
import java.io.PrintStream;

public class DeleteUpdate {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Database st = new Database("test/Allegory/startrek/TestData/cast.startrek.pl");
            ErrorReport er = new ErrorReport();

            // updates
            // U1: delete each vulcan from the database
            System.out.println("------------------------------------");
            System.out.println("U1: delete each human from the database");
            crewmanTable ct = st.crewman.select(c -> c.species.equals("human"));
            for (crewman c : ct.tuples()) {
                st.crewman.delete(c);
            }
            st.print();

            // U2: now remove association class tuples or nullify pointers
            System.out.println("------------------------------------");
            System.out.println("U2: now remove association class tuples or nullify pointers");
            ct.forEach(c -> st.asg.select(a -> a.hasCrew.id == c.id).forEach(as -> st.asg.delete(as)));
            st.print();

            st.print(new PrintStream("trash/output.startrek.pl"));
            ConformST.main("trash/output.startrek.pl");

            // U3: make each trill Trill
            System.out.println("------------------------------------");
            System.out.println("\nU3: make each trill on ds9 a Trill");
            st.crewman.select(c -> c.species.equals("trill")).forEach(t -> t.species = "Trill");
            st.print();

            st.print(new PrintStream("trash/output1.startrek.pl"));
            ConformST.main("trash/output1.startrek.pl");
        } catch (FileNotFoundException ex) {
            System.err.println(ex.getMessage());
        }
    }

}
